import unittest
import json
from timer import Timer

class TestNFilter(unittest.TestCase):
    def __init__(self, *args):
        super().__init__(*args)
        pass

    def setUp(self):
        pass

    def test_connect1(self):
        from iim42652_spi import iim42652
        s = iim42652.getIIM42652()
        self.assertTrue(s.connected)
        print(s)
        print(s.spi)

    def test_nfilter_settings(self):

        from iim42652_spi import iim42652
        s = iim42652.getIIM42652()

        minF = 120
        maxF = 4000
        nTest = 3000

        axes = ['X', 'Y', 'Z']
        maxErr = 0
        maxRelErr = 0

        freqSeen = {}

        for i in range(nTest):
            testF = minF + (maxF - minF) * i / 3000

            for a in axes:
                s[f'gyro{a}NFilterFreq'] = testF
                outF = s[f'gyro{a}NFilterFreq']

                errF = abs(testF - outF)
                errFRel = errF / testF

                #print(f'{i}: {testF} {a} => {outF}, error {errF}, rel. {errFRel}')
                self.assertTrue(errFRel < 1e-1)

                outFr = round(outF*10) / 10

                if outFr not in freqSeen:
                    freqSeen[outFr] = 1
                    print(f'Notch filter frequency setting: {outFr} Hz')

                if errF > maxErr:
                    maxErr = errF
                    maxErrF = (testF, outF)
                if errFRel > maxRelErr:
                    maxRelErr = errFRel
                    maxRelErrF = (testF, outF)
        print(f'max abs. freq error: {maxErr} @ {maxErrF}')
        print(f'max rel. freq error: {maxRelErr} @ {maxRelErrF}')
