import time

class Timer:
    t0 = 0
    t1 = 0
    def __enter__(self):
        self.t0 = time.time()
    def __exit__(self, *args):
        self.t1 = time.time()
    def __call__(self):
        return self.elapsed()
    def __str__(self):
        return f'{self.elapsed()} s'
    def elapsed(self):
        return self.t1 - self.t0

